from datetime import datetime
from typing import Optional

from cpl_core.database import TableABC

from bot_data.abc.history_table_abc import HistoryTableABC
from bot_data.model.server import Server


class Achievement(HistoryTableABC):
    def __init__(
        self,
        name: str,
        attribute: str,
        operator: str,
        value: str,
        server: Optional[Server],
        deleted: bool,
        date_from: str,
        date_to: str,
        id=0,
    ):
        HistoryTableABC.__init__(self)

        self._id = id
        self._name = name
        self._attribute = attribute
        self._operator = operator
        self._value = value
        self._server = server

        self._deleted = deleted
        self._date_from = date_from
        self._date_to = date_to

    @property
    def id(self) -> int:
        return self._id

    @property
    def name(self) -> str:
        return self._name

    @name.setter
    def name(self, value: str):
        self._name = value

    @property
    def operator(self) -> str:
        return self._operator

    @operator.setter
    def operator(self, value: str):
        self._operator = value

    @property
    def value(self) -> str:
        return self._value

    @value.setter
    def value(self, value: str):
        self._value = value

    @property
    def server(self) -> Server:
        return self._server
