from ariadne import MutationType

from bot_graphql.mutations.achievement_mutation import AchievementMutation
from bot_graphql.mutations.auto_role_mutation import AutoRoleMutation
from bot_graphql.mutations.auto_role_rule_mutation import AutoRoleRuleMutation
from bot_graphql.mutations.level_mutation import LevelMutation
from bot_graphql.mutations.user_joined_game_server_mutation import UserJoinedGameServerMutation
from bot_graphql.mutations.user_mutation import UserMutation


class Mutation(MutationType):
    def __init__(
        self,
        auto_role_mutation: AutoRoleMutation,
        auto_role_rule_mutation: AutoRoleRuleMutation,
        level_mutation: LevelMutation,
        user_mutation: UserMutation,
        achievement_mutation: AchievementMutation,
        user_joined_game_server: UserJoinedGameServerMutation,
    ):
        MutationType.__init__(self)

        self.set_field("autoRole", lambda *_: auto_role_mutation)
        self.set_field("autoRoleRule", lambda *_: auto_role_rule_mutation)
        self.set_field("level", lambda *_: level_mutation)
        self.set_field("user", lambda *_: user_mutation)
        self.set_field("achievement", lambda *_: achievement_mutation)
        self.set_field("userJoinedGameServer", lambda *_: user_joined_game_server)
