export class Mutations {
  static updateUser = `
    mutation updateUser($id: ID, $xp: Int, $levelId: ID) {
      user {
        updateUser(input: { id: $id, xp: $xp, levelId: $levelId }) {
          id
          name
          xp
          level {
            id
            name
          }
        }
      }
    }
  `;

  static createAutoRole = `
    mutation createAutoRole($serverId: ID, $channelId: String, $messageId: String) {
      autoRole {
        createAutoRole(input: { serverId: $serverId, channelId: $channelId, messageId: $messageId }) {
          id
          channelId
          channelName
          messageId
        }
      }
    }
  `;

  static deleteAutoRole = `
    mutation deleteAutoRole($id: ID) {
      autoRole {
        deleteAutoRole(id: $id) {
          id
          channelId
          channelName
          messageId
        }
      }
    }
  `;

  static createAutoRoleRule = `
    mutation createAutoRoleRule($autoRoleId: ID, $emojiName: String, $roleId: String) {
      autoRoleRule {
        createAutoRoleRule(input: { autoRoleId: $autoRoleId, emojiName: $emojiName, roleId: $roleId }) {
          id
          emojiName
          roleId
          roleName
        }
      }
    }
  `;

  static updateAutoRoleRule = `
    mutation updateAutoRoleRule($id: ID, $emojiName: String, $roleId: String) {
      autoRoleRule {
        updateAutoRoleRule(input: { id: $id, emojiName: $emojiName, roleId: $roleId }) {
          id
          emojiName
          roleId
          roleName
        }
      }
    }
  `;

  static deleteAutoRoleRule = `
    mutation deleteAutoRoleRule($id: ID) {
      autoRoleRule {
        deleteAutoRoleRule(id: $id) {
          id
          emojiName
          roleId
          roleName
        }
      }
    }
  `;

  static createLevel = `
    mutation createLevel($name: String, $color: String, $minXp: Int, $permissions: String, $serverId: ID) {
      level {
        createLevel(input: { name: $name, color: $color, minXp: $minXp, permissions: $permissions, serverId: $serverId}) {
          id
          name
          color
          minXp
          permissions
          server {
            id
          }
        }
      }
    }
  `;

  static updateLevel = `
    mutation updateLevel($id: ID, $name: String, $color: String, $minXp: Int, $permissions: String) {
      level {
        updateLevel(input: { id: $id, name: $name, color: $color, minXp: $minXp, permissions: $permissions }) {
          id
          name
          color
          minXp
          permissions
        }
      }
    }
  `;

  static deleteLevel = `
    mutation deleteLevel($id: ID) {
      level {
        deleteLevel(id: $id) {
          id
          name
        }
      }
    }
  `;

  static createAchievement = `
    mutation createAchievement($name: String, $attribute: String, $operator: String, $value: String, $serverId: ID) {
      achievement {
        createAchievement(input: { name: $name, attribute: $attribute, operator: $operator, value: $value, serverId: $serverId}) {
          id
          name
          attribute
          operator
          value
          server {
            id
          }
        }
      }
    }
  `;

  static updateAchievement = `
    mutation updateAchievement($id: ID, $name: String, $attribute: String, $operator: String, $value: String) {
      achievement {
        updateAchievement(input: { id: $id, name: $name, attribute: $attribute, operator: $operator, value: $value}) {
          id
          name
          attribute
          operator
          value
        }
      }
    }
  `;

  static deleteAchievement = `
    mutation deleteAchievement($id: ID) {
      achievement {
        deleteAchievement(id: $id) {
          id
          name
        }
      }
    }
  `;
}
